<?php
	error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_DEPRECATED);
	session_start();
	
	$clientId = "***";
	$clientSecret = "**";
	$redirectURL = "http://test.dev/youtubeapi/oauthresponse.php";


	// Google will redirect to this url if OAuth works

	if ($_GET["code"] != null && $_GET["code"] != "") {

		// we have auth code. now we need to send it to back to google to 
		// get access tokens

		$url = "https://www.googleapis.com/oauth2/v4/token";

		$data = array("client_id"=>$clientId,"client_secret"=>$clientSecret, "redirect_uri"=>$redirectURL,
				"code"=>$_GET["code"],"grant_type"=>"authorization_code", "response_type"=>"code");
		

		$curl = curl_init();
		curl_setopt_array($curl, array(
					CURLOPT_RETURNTRANSFER => 1,
					CURLOPT_URL => $url,
					CURLOPT_USERAGENT => 'YouTube API Tester',
					CURLOPT_SSL_VERIFYPEER => 1,
					CURLOPT_SSL_VERIFYHOST=> 0,
					CURLOPT_CAINFO => "cert/cacert.pem",
					CURLOPT_CAPATH => "cert/cacert.pem",
					CURLOPT_FOLLOWLOCATION => TRUE,
					CURLOPT_POST=>true,
					CURLOPT_POSTFIELDS=>$postText = http_build_query($data)
					));
		$resp = curl_exec($curl);

		curl_close($curl);

		$f = fopen("data/response.txt", "w");
		if ($f) {
			fwrite($f, serialize($resp));
			fclose($f);

			$arrResp = json_decode($resp, true);
			$accessToken = $arrResp["access_token"];
			$_SESSION["access_token"] = $accessToken;
			

		} else
			exit("Error writing to response.txt");
		if ($_SESSION["code_id"]) {
			header("Location:" . $_SESSION["code_id"]);
			exit;
		}	
	} else {
		// if no code was returned then something failed
		//. Remove the response.txt from the folder

		@unlink("data/response.txt");
	}
	
?>
